<template>
  <a-spin :spinning="confirmLoading">
    <j-form-container :disabled="formDisabled">
      <a-form :form="form" slot="detail">
        <a-row>
          <a-col :span="24">
            <a-form-item label="设备名称" :labelCol="labelCol" :wrapperCol="wrapperCol">
              <j-select-device placeholder="请选择设备名称" :multiple="false" v-decorator="['deviceId', {}]"/>
            </a-form-item>
          </a-col>
          <a-col :span="24">
            <a-form-item label="设备状态" :labelCol="labelCol" :wrapperCol="wrapperCol">
              <j-dict-select-tag v-decorator="['deviceStatus']" dict-code="device_status"
                                 placeholder="请选择设备状态" :trigger-change="true" />
            </a-form-item>
          </a-col>
          <a-col :span="24">
            <a-form-item label="提交人" :labelCol="labelCol" :wrapperCol="wrapperCol">
              <j-select-user-by-dep v-decorator="['submitId']" :multi="false" />
            </a-form-item>
          </a-col>
          <a-col :span="24">
            <a-form-item label="提交时间" :labelCol="labelCol" :wrapperCol="wrapperCol">
              <j-date placeholder="请选择提交时间" v-decorator="['submitTime']" :trigger-change="true"
                      :show-time="true" date-format="YYYY-MM-DD HH:mm:ss" style="width: 100%" />
            </a-form-item>
          </a-col>
          <a-col :span="24">
            <a-form-item label="现象描述" :labelCol="labelCol" :wrapperCol="wrapperCol">
              <a-input v-decorator="['description']" placeholder="请输入现象描述"  ></a-input>
            </a-form-item>
          </a-col>
          <a-col :span="24">
            <a-form-item label="图片" :labelCol="labelCol" :wrapperCol="wrapperCol">
              <j-image-upload isMultiple v-decorator="['img']" ></j-image-upload>
            </a-form-item>
          </a-col>
          <a-col :span="24">
            <a-form-item label="委派人" :labelCol="labelCol" :wrapperCol="wrapperCol">
              <j-select-user-by-dep v-decorator="['assignerId']" :multi="false" />
            </a-form-item>
          </a-col>
          <a-col :span="24">
            <a-form-item label="维修人" :labelCol="labelCol" :wrapperCol="wrapperCol">
              <j-select-user-by-dep v-decorator="['maintainerId']" />
            </a-form-item>
          </a-col>
        </a-row>
      </a-form>
    </j-form-container>
  </a-spin>
</template>

<script>
import JSelectMultiUser from '@comp/jeecgbiz/JSelectMultiUser'
import JFormContainer from '@comp/jeecg/JFormContainer'
import JDate from '@comp/jeecg/JDate'
import JUpload from '@comp/jeecg/JUpload'
import JImageUpload from '@comp/jeecg/JImageUpload'
import JSelectDepart from '@comp/jeecgbiz/JSelectDepart'
import JSelectUserByDep from '@comp/jeecgbiz/JSelectUserByDep'
import pick from 'lodash.pick'
import { getAction, httpAction } from '@api/manage'
import JSelectDevice from '@comp/jeecgbiz/JSelectDevice'

export default {
  name: 'BuRepairRecordAddForm',
  components: {
    JSelectMultiUser,
    JFormContainer,
    JDate,
    JUpload,
    JImageUpload,
    JSelectDepart,
    JSelectUserByDep,
    JSelectDevice,
  },
  props:{
    //流程表单data
    formData: {
      type: Object,
      default: ()=>{},
      required: false
    },
    //表单模式：true流程表单 false普通表单
    formBpm: {
      type: Boolean,
      default: false,
      required: false
    },
    //表单禁用
    disabled: {
      type: Boolean,
      default: false,
      required: false
    }
  },
  data () {
    return {
      form: this.$form.createForm(this),
      model: {},
      orgCode:"",
      labelCol: {
        xs: { span: 24 },
        sm: { span: 5 },
      },
      wrapperCol: {
        xs: { span: 24 },
        sm: { span: 16 },
      },
      confirmLoading: false,
      validatorRules: {
      },
      url: {
        add: "/repair/buRepairRecord/add",
        edit: "/repair/buRepairRecord/edit",
        queryById: "/repair/buRepairRecord/queryById"
      }
    }
  },
  computed: {
    formDisabled(){
      if(this.formBpm===true){
        if(this.formData.disabled===false){
          return false
        }
        return true
      }
      return this.disabled
    },
    showFlowSubmitButton(){
      if(this.formBpm===true){
        if(this.formData.disabled===false){
          return true
        }
      }
      return false
    }
  },
  created () {
    //如果是流程中表单，则需要加载流程表单data
    this.showFlowData();
  },
  methods: {
    add () {
      this.edit({});
    },
    edit (record) {
      this.form.resetFields();
      this.model = Object.assign({}, record);
      this.visible = true;
      this.$nextTick(() => {
        this.form.setFieldsValue(pick(this.model,'deviceId','deviceStatus','submitId','submitTime','description','img',
          'assignerId','maintainerId','startTime','endTime','method','inspector','video','assignTime','repairGrade', 'repairType',
          'orgCode','reason','acceptTime','repairResult'))
      })
    },
    //渲染流程表单数据
    showFlowData(){
      if(this.formBpm === true){
        let params = {id:this.formData.dataId};
        getAction(this.url.queryById,params).then((res)=>{
          if(res.success){
            this.edit (res.result);
          }
        });
      }
    },
    submitForm () {
      const that = this;
      // 触发表单验证
      this.form.validateFields((err, values) => {
        if (!err) {
          that.confirmLoading = true;
          let httpurl = '';
          let method = '';
          if(!this.model.id){
            httpurl+=this.url.add;
            method = 'post';
          }else{
            httpurl+=this.url.edit;
            method = 'put';
          }
          let formData = Object.assign(this.model, values);
          console.log("表单提交数据",formData)
          httpAction(httpurl,formData,method).then((res)=>{
            if(res.success){
              that.$message.success(res.message);
              that.$emit('ok');
            }else{
              that.$message.warning(res.message);
            }
          }).finally(() => {
            that.confirmLoading = false;
          })
        }

      })
    },
    popupCallback(row){
      this.form.setFieldsValue(pick(row,'deviceId','deviceStatus','submitId','submitTime','description','img','assignerId',
        'maintainerId','startTime','endTime','method','inspector','video','assignTime','repairGrade','repairType',
        'orgCode','reason','acceptTime','repairResult'))
    },
  }
}
</script>